"""Turn into N-to-M for dedup

Revision ID: 839626f768e3
Revises: 6de51673a0ef
Create Date: 2022-01-07 23:28:41.493017

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = "839626f768e3"
down_revision = "6de51673a0ef"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "configuration_to_component_record",
        sa.Column("configuration", sa.Integer(), nullable=False),
        sa.Column("component_record", sa.Integer(), nullable=False),
        sa.ForeignKeyConstraint(
            ["component_record"],
            ["component_record.id"],
            name=op.f("fk_configuration_to_component_record_component_record_component_record"),
        ),
        sa.ForeignKeyConstraint(
            ["configuration"],
            ["configuration.id"],
            name=op.f("fk_configuration_to_component_record_configuration_configuration"),
        ),
        sa.PrimaryKeyConstraint(
            "configuration", "component_record", name=op.f("pk_configuration_to_component_record")
        ),
    )
    op.drop_constraint("uq_component_record_config_id", "component_record", type_="unique")
    op.drop_constraint(
        "fk_component_record_config_id_configuration", "component_record", type_="foreignkey"
    )
    op.drop_column("component_record", "config_id")
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column(
        "component_record",
        sa.Column("config_id", sa.INTEGER(), autoincrement=False, nullable=False),
    )
    op.create_foreign_key(
        "fk_component_record_config_id_configuration",
        "component_record",
        "configuration",
        ["config_id"],
        ["id"],
    )
    op.create_unique_constraint(
        "uq_component_record_config_id", "component_record", ["config_id", "component"]
    )
    op.drop_table("configuration_to_component_record")
    # ### end Alembic commands ###
